import cv2
import os
import time
# 图片路径
def mark_pic(change_size,file_name,SHOW_FILE=False,SHOW_DATA=False,SHOW_point=True):
    if(SHOW_FILE==True):
        print(file_name)
    img = cv2.imread(file_name)
    a = []
    sep = ','
    #path2='_tf_gt'
    #############如果是标定边框，使用下面的path
    path2='_ed_gt'
    path=file_name[:-7]+path2+'.txt'
    file=open(path,'w')

    def on_EVENT_LBUTTONDOWN(event, x, y,flag,param):
        #cv2.setMouseCallback("image", on_EVENT_RBUTTONDOWN)
        if event == cv2.EVENT_RBUTTONDOWN:
            cv2.moveWindow("image", 960-int(1080*x/1900), 540-int(1080*y/2533))
            print(x,y)
        if event == cv2.EVENT_LBUTTONDOWN:
            xy = "%d,%d" % (x, y)
            xx=int(x/change_size)
            yy=int(y/change_size)
            text="%d,%d" % (xx, yy)
            a.append(str(x))
            a.append(str(y))
            cv2.circle(img, (x, y), 3, (0, 0, 255), thickness=-1)
            if SHOW_point==True:
                cv2.putText(img, xy, (x, y), cv2.FONT_HERSHEY_PLAIN,
                            2.0, (0, 0, 0), thickness=2)
            cv2.imshow("image", img)



    cv2.namedWindow("image",cv2.WINDOW_NORMAL)

    cv2.setMouseCallback("image", on_EVENT_LBUTTONDOWN)
    #

    cv2.imshow("image", img)

    W_size=int(1080*change_size)
    H_size=int(1920*change_size)
    cv2.resizeWindow('image', W_size,H_size )
    #
    key=999

    while(key!=0):
        key = cv2.waitKey(0)
        if key==ord('1'):
            flag='\n'
        else:
            break
        if(SHOW_DATA==True):
            print(a)
        file.write(sep.join(a))
        a=[]
        file.write(flag)
    cv2.waitKey(0)
    file.close()


if __name__=="__main__":
    dir = os.getcwd()
    im_names = []
    wildcard = ".jpg"  # 读取jpg图片
    exts = wildcard.split(" ")
    files = os.listdir(dir)
    #video_8_3_227.jpg
    ###############################################################
    last_time_name='000013_in.jpg'#修改进度，本次标定从本图开始，否则为files[0]
    ###############################################################
    workflag=1
    for name in files:
        if name!=last_time_name and workflag:
            continue
        else:
            workflag=0
            fullname = os.path.join(dir, name)
            for ext in exts:
                if (name.endswith(ext)):
                    mark_pic(1, name,SHOW_FILE=True,SHOW_DATA=True,SHOW_point=True)
                    #参数1为调整窗口大小，3为是否显示文件名，4为是否显示标定数据,5为是否在图上显示点数据

                    break

